#include <cv.h>
#include <highgui.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>

#define MAXTAP 400
#define SCALEX 640
#define SCALEY 320
#define OFTX 40
#define OFTY 20
#define STEPX 4

void filter(float inL, float inR, float* outL, float* outR);
void TxtLoad(char *fn, float *iW);
void GetPutWavInfo(char *fn);
void put_ubyte(short x, FILE *f);
void put_ushort(short x, FILE *f);
void put_ulong(long x, FILE *f);
void WaveDraw(CvArr* img, int x1, int y1, float *InW, CvScalar col);
float Pi = 3.1415926;
int TapN;
	float hh[400];
	float iw[500];
	float ow[500];
	float InDataL;
	float InDataR;
	float OutDataL;
	float OutDataR;
	int dotn = 500;
	int xstep = 1;
	int xstart = 0;
	int yframe = 100;
	int yrng = 10000;
	short mono1_stereo2;
	long samplingfreq;
	short bitlength;
	long totalbytes;
	long bytesinfile;
	short chbytes_per_sample;
	short bytes_per_sample;
	long bytes_per_sec;
	long wavesize;
	float timelength;
	unsigned get_ubyte(FILE *f);
	unsigned get_ushort(FILE *f);
	unsigned long get_ulong(FILE *f);
float freq_range;
float Fsamp;
float ringbufl[MAXTAP];
float ringbufr[MAXTAP];
int N = 0;

int main(int argc, char *argv[]) {

  char input_file[256];
  char wave_file[256];
  IplImage *img;
  int val, valp1;
  int i;
  long tmplong;

  printf( "sizeof is %d.\n", sizeof(tmplong) );

  img = cvCreateImage (cvSize (720, 570), 8, 3);

  cvSet (img, cvScalarAll (255), 0);

  if (argc < 2) {
      fprintf(stderr, "1st arg must be input file name.\n");
      return -1;
  }

  strcpy(input_file, argv[1]);
  strcpy(wave_file, argv[2]);

  TxtLoad(input_file, hh);

  GetPutWavInfo(wave_file);

		WaveDraw(img, 80, 160, iw, CV_RGB(255, 0, 0));
		WaveDraw(img, 80, 410, ow, CV_RGB(0, 0, 255));
	
    while(1) {
        cvNamedWindow ("Waveform", CV_WINDOW_AUTOSIZE);
        cvShowImage ("Waveform", img);
        if(cvWaitKey(1)>=0) break;
    }
  return 0;
}

void WaveDraw(CvArr* img, int x1, int y1, float *InW, CvScalar col)
{
	int i;
	int ytmp1, ytmp2;
	char tmpchar[12];
	int xscale = 500;
	int yscale = 100;

  CvFont font;
  int font_face[] = {
    CV_FONT_HERSHEY_SIMPLEX,
    CV_FONT_HERSHEY_PLAIN,
    CV_FONT_HERSHEY_DUPLEX,
    CV_FONT_HERSHEY_COMPLEX,
    CV_FONT_HERSHEY_TRIPLEX,
    CV_FONT_HERSHEY_COMPLEX_SMALL,
    CV_FONT_HERSHEY_SCRIPT_SIMPLEX,
    CV_FONT_HERSHEY_SCRIPT_COMPLEX
  };

  cvInitFont(&font, font_face[0], 0.5, 0.5, 0, 1, 8);

	sprintf(tmpchar,"%7d", yrng);
	cvPutText(img, tmpchar, cvPoint( x1 - 70, y1 - yscale - 8), &font, CV_RGB(0, 0, 0));
	sprintf(tmpchar,"%6d", -yrng);
	cvPutText(img, tmpchar, cvPoint( x1 - 70, y1 + yscale - 8), &font, CV_RGB(0, 0, 0));
	cvPutText(img, "0", cvPoint( x1 - 20, y1 - 8), &font, CV_RGB(0, 0, 0));

	sprintf(tmpchar,"%7.4f", (float)(dotn/2)/Fsamp);
	cvPutText(img, tmpchar, cvPoint( x1 + xscale/2 - 30, y1 + yscale + 15), &font, CV_RGB(0, 0, 0));
	sprintf(tmpchar,"%7.4f", (float)dotn/Fsamp);
	cvPutText(img, tmpchar, cvPoint( x1 + xscale - 30, y1 + yscale + 15), &font, CV_RGB(0, 0, 0));

	cvPutText(img, "[s]", cvPoint( x1 + xscale + 60, y1 + yscale + 15), &font, CV_RGB(0, 0, 0));
	cvPutText(img, "0", cvPoint( x1 + 10, y1 + yscale + 15), &font, CV_RGB(0, 0, 0));

	cvLine(img, cvPoint(x1, y1), cvPoint(x1 + xscale, y1), CV_RGB(100, 100, 100), 1, 8, 0);

	cvLine(img, cvPoint(x1, y1 - yscale), cvPoint(x1 + xscale, y1 - yscale), CV_RGB(100, 100, 100), 1, 8, 0);

	cvLine(img, cvPoint(x1, y1 + yscale), cvPoint(x1 + xscale, y1 + yscale), CV_RGB(100, 100, 100), 1, 8, 0);

	cvLine(img, cvPoint(x1, y1 - yscale), cvPoint(x1, y1 + yscale), CV_RGB(100, 100, 100), 1, 8, 0);
	cvLine(img, cvPoint(x1 + xscale * 1 / 4, y1 - yscale), cvPoint(x1 + xscale * 1 / 4, y1 + yscale), CV_RGB(100, 100, 100), 1, 8, 0);
	cvLine(img, cvPoint(x1 + xscale * 2 / 4, y1 - yscale), cvPoint(x1 + xscale * 2 / 4, y1 + yscale), CV_RGB(100, 100, 100), 1, 8, 0);
	cvLine(img, cvPoint(x1 + xscale * 3 / 4, y1 - yscale), cvPoint(x1 + xscale * 3 / 4, y1 + yscale), CV_RGB(100, 100, 100), 1, 8, 0);
	cvLine(img, cvPoint(x1 + xscale, y1 - yscale), cvPoint(x1 + xscale, y1 + yscale), CV_RGB(100, 100, 100), 1, 8, 0);

	for(i = 0; i < dotn-1; i++) {
		ytmp1 = (int)(-yscale * InW[i+0] / yrng);
		if( ytmp1 > yscale ) ytmp1 = yscale;
		if( ytmp1 < -yscale ) ytmp1 = -yscale;
		ytmp2 = (int)(-yscale * InW[i+1] / yrng);
		if( ytmp2 > yscale ) ytmp2 = yscale;
		if( ytmp2 < -yscale ) ytmp2 = -yscale;
		cvLine(img, cvPoint(x1 + (i+0) * xstep, y1 + ytmp1), cvPoint(x1 + (i+1) * xstep, y1 + ytmp2), col, 1, 8, 0);
	}
}

void GetPutWavInfo(char *fn) {
  unsigned long len;
  unsigned char s[10];
  int i;
  int numwritten;
  long fmtbytes;
  FILE *ifp;
  FILE *ofp;

	ifp = fopen( fn, "rb" );
	if (ifp != NULL) {
		fread(s, 4, 1, ifp); // "RIFF" 
		bytesinfile = get_ulong(ifp); // total bytes in the file
		fread(s, 8, 1, ifp); // "WAVEfmt" 
		fmtbytes = get_ulong(ifp); // header size
		len = get_ushort(ifp); // 1: pcm
		mono1_stereo2 = get_ushort(ifp); // 1: mono, 2; stereo
		samplingfreq = get_ulong(ifp); // sampling frequency
		Fsamp = (float)samplingfreq;
		freq_range = Fsamp/2;
		bytes_per_sec = get_ulong(ifp); // bytes per second
		chbytes_per_sample = get_ushort(ifp); // channels * bytes per sample
		bitlength = get_ushort(ifp); // bit length
		if( bitlength == 16 ) yrng = 10000; else yrng = 100;
		xstart = 0;
		for (i = 0; i < (fmtbytes-16)/2; i++ ) {
			len = get_ushort(ifp); // skip redundant header information
		}
		do{ // look for "data" chunk
			fread(s, 4, 1, ifp); // expect "data"
			if(((s[0] == 'd')&(s[1] == 'a')&(s[2] == 't')&(s[3] == 'a')) == 0){ // step over chunks unless it's "data" chunk
				len = get_ulong(ifp);
				fseek(ifp, len, SEEK_CUR);
			}else{
				break ;
			}
		} while(1);
		totalbytes = get_ulong(ifp); // total bytes of wav data
		bytes_per_sample = bitlength / 8;
		wavesize = totalbytes / (mono1_stereo2 * bytes_per_sample);
		timelength = (float)wavesize/Fsamp;
		int i, m;
		short x;
  printf( "samplingfreq is %d.\n", samplingfreq );
  printf( "totalbytes is %d.\n", totalbytes );
  printf( "wavesize is %d.\n", wavesize );
  printf( "bytes_per_sample is %d.\n", bytes_per_sample );
  printf( "mono1_stereo2 is %d.\n", mono1_stereo2 );
  printf( "timelength is %f.\n", timelength );

		/////////////////////////////////////////
		// put wav info
		ofp = fopen( "out.wav", "wb" );
		sprintf(s, "RIFF"); 
		numwritten = fwrite( s, 4, 1, ofp );
		put_ulong(bytesinfile, ofp); // total bytes in the file
		sprintf(s, "WAVEfmt "); 
		numwritten = fwrite( s, 8, 1, ofp );
		put_ulong(16, ofp); // 16 bytes -- always
		put_ushort(1, ofp); // 1: pcm
		put_ushort(mono1_stereo2, ofp); // 1: mono, 2; stereo
		put_ulong(samplingfreq, ofp); // sampling frequency	
		put_ulong(bytes_per_sec, ofp); // bytes per second
		put_ushort(chbytes_per_sample, ofp); // channels * bytes per sample
		put_ushort(bitlength, ofp); // bit length
		sprintf(s, "datafmt "); 
		numwritten = fwrite( s, 4, 1, ofp );
		put_ulong(totalbytes, ofp); // total bytes of wav data
		/////////////////////////////////////////

		if (mono1_stereo2 == 1) {
			for (i = 0; i < wavesize; i++) { // read mono wav data
				if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
				if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
				else x = (short)(s[0]) - 128;
				InDataL = (float)(x);
				if(i < 500) iw[i] = InDataL;

				/////////////////////////////////////////
				// execute filter
				filter(InDataL, InDataR, &OutDataL, &OutDataR);

				/////////////////////////////////////////
				// put wav data
				if (bytes_per_sample == 2) 
					put_ushort((short)OutDataL, ofp);
				else 
					put_ubyte((short)OutDataL, ofp);
				if(i < 500) ow[i] = OutDataL;
			}
		} else {
			for (i = 0; i < wavesize * 2; i++) { // read stereo wav data
				m = i / 2;
				if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
				if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
				else x = (short)(s[0]) - 128;
				if(i%2==0) InDataL = (float)(x);
				else InDataR = (float)(x);
				if(m < 500) iw[m] = InDataL;

				/////////////////////////////////////////
				// execute filter
				if(i%2==1) {
					filter(InDataL, InDataR, &OutDataL, &OutDataR);
					/////////////////////////////////////////
					// put wav data
					if (bytes_per_sample == 2) {
						put_ushort((short)OutDataL, ofp);
						put_ushort((short)OutDataR, ofp);
					} else {
						put_ubyte((short)OutDataL, ofp);
						put_ubyte((short)OutDataR, ofp);
					}
					if(m < 500) ow[m] = OutDataL;
				}
			}
		}

		/////////////////////////////////////////
		fclose( ifp );
		fclose( ofp );
	}
}

unsigned long get_ulong(FILE *f)
{
    unsigned char s[4];
	unsigned res;

    if (fread(s, 4, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256LU * (s[1] + 256LU * (s[2] + 256LU * s[3]));
	}
    return res;
}

unsigned get_ushort(FILE *f)
{
    unsigned char s[2];
	unsigned res;

    if (fread(s, 2, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256U * s[1];
	}
    return res;
}

unsigned get_ubyte(FILE *f)
{
    unsigned char s[1];
	unsigned res;

    if (fread(s, 1, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0];
	}
    return res;
}

void TxtLoad(char *fn, float *iW)
{
  int count = 0;
  char charline[40];
  FILE *fp;

  fp = fopen( fn, "r" );
  if( fp == NULL ){
    printf( "%s cannot be opened.\n", fn );
    exit(1);
  }

  fseek( fp, 0L, SEEK_SET );
  while( fgets(charline, 40, fp) != NULL ) {
    iW[count] = atof(charline);
    count++;

    if(count == MAXTAP) {
      break;
    }
  }
  TapN = count;
  printf( "TapN = %d\n", TapN );
  fclose( fp );
}

void put_ulong(long x, FILE *f)
{
    unsigned char s[4];
	long divident;
	int numwritten;

	s[3] = (unsigned char)(x / 256LU / 256LU / 256LU);
	divident = x - s[3] * 256LU * 256LU * 256LU;
	s[2] = (unsigned char)(divident / 256LU / 256LU);
	divident = x - s[3] * 256LU * 256LU * 256LU - s[2] * 256LU * 256LU;
	s[1] = (unsigned char)(divident / 256LU);
	s[0] = (unsigned char)(x - s[3] * 256LU * 256LU * 256LU 
			- s[2] * 256LU * 256LU - s[1] * 256LU);

	numwritten = fwrite( s, 4, 1, f );
}

void put_ushort(short x, FILE *f)
{
    unsigned char s[2];
	int numwritten;

	s[1] = (unsigned char)(x / 256LU);
	s[0] = (unsigned char)(x - s[1] * 256LU);

	numwritten = fwrite( s, 2, 1, f );
}

void put_ubyte(short x, FILE *f)
{
    unsigned char s[1];
	int numwritten;

	s[0] = (unsigned char)(x + 128);

	numwritten = fwrite( s, 1, 1, f );
}

void filter(float inL, float inR, float* outL, float* outR) {
  int k, ml, mr;
  float accl, accr;

    accl = 0;
    accr = 0;
    ml = 0;
    mr = 0;

        ringbufl[N] = inL;
        ringbufr[N] = inR;

        for(k = N; k >= 0; k--, ml++) accl += (ringbufl[k] * hh[ml]);
        for(k = TapN-1; k >= N+1; k--, ml++) accl += (ringbufl[k] * hh[ml]);
        *outL = accl;

        for(k = N; k >= 0; k--, mr++) accr += (ringbufr[k] * hh[mr]);
        for(k = TapN-1; k >= N+1; k--, mr++) accr += (ringbufr[k] * hh[mr]);
        *outR = accr;

        if(N == TapN-1) N = 0;
        else N++;

//        printf( "%f,    %f\n", inR, *outR );
}

